local BTP = BTP
local stamina_counter_visibility = BTP:GetOption("show_stamina_counter")
local ping_counter_visibility = BTP:GetOption("show_ping_counter")
local avatar_position = BTP:GetOption("panel_style_position")
local avatar_replace = avatar_position == 1
function HUDTeammate:InitBTP()
    if avatar_replace then
        local y = self._panel:child("mask"):y()
        local radial_size = 44
        local avatar_screen_size = 3
        local x = 3
        if self._main_player then
            radial_size = 60
            avatar_screen_size = 4
            x = 4
        end
        local armor_size = radial_size + (avatar_screen_size * 3)
        local avatar_size = radial_size + avatar_screen_size
        local avatar = self._player_panel:bitmap({
            name = "avatar",
            texture = "guis/textures/pd2_mod_btp/avatar_none",
            layer = 10,
            render_template = "VertexColorTexturedRadial",
            w = avatar_size,
            h = avatar_size,
            x = x,
            y = y,
            visible = true
        })
        avatar:set_bottom(self._player_panel:h() - x)
        self._avatar = avatar

        self.armor_texture = "guis/textures/pd2_mod_btp/hud_armor_" .. BTP:GetOption("armor_color")

        local avatar_armor = self._player_panel:bitmap({
            name = "avatar_armor",
            texture = self.armor_texture,
            layer = 11,
            render_template = "VertexColorTexturedRadial",
            w = armor_size,
            h = armor_size,
            x = 0,
            y = y,
            color = Color(1, 0, 1, 1),
            visible = true
        })
        avatar_armor:set_bottom(self._player_panel:h())

        local avatar_ability_radial = self._player_panel:bitmap({
            name = "ability_meter",
            texture = "guis/textures/pd2_mod_btp/hud_ability_radial",
            layer = 13,
            render_template = "VertexColorTexturedRadial",
            w = armor_size,
            h = armor_size,
            x = 0,
            y = y,
            visible = true,
            color = Color(1, 0, 0, 0)
        })
        avatar_ability_radial:set_bottom(self._player_panel:h())

        local avatar_ability_radial_icon = self._player_panel:bitmap({
            blend_mode = "add",
            name = "ability_icon",
            visible = false,
            layer = 13,
            w = radial_size * 0.5,
            h = radial_size * 0.5
        })
        avatar_ability_radial_icon:set_center(self._player_panel:child("avatar"):center())

        local avatar_swan_song = self._player_panel:bitmap({
            name = "avatar_swan_song",
            texture = "guis/textures/pd2_mod_btp/hud_swan_song",
            layer = 16,
            render_template = "VertexColorTexturedRadial",
            w = armor_size,
            h = armor_size,
            x = 0,
            y = y,
            visible = false,
            color = Color(1, 0, 0, 0)
        })
        avatar_swan_song:set_bottom(self._player_panel:h())

        local radial_rip = self._player_panel:bitmap({
            name = "radial_rip",
            texture = "guis/textures/pd2_mod_btp/hud_armor_" .. BTP:GetOption("radial_rip_color"),
            layer = 15,
            render_template = "VertexColorTexturedRadial",
            w = avatar_size,
            h = avatar_size,
            x = x,
            y = y,
            visible = true,
            color = Color(1, 0, 0, 0)
        })
        radial_rip:set_bottom(self._player_panel:h() - 4)

        local stoic_health = self._player_panel:bitmap({
            name = "stoic_health",
            texture = "guis/textures/pd2_mod_btp/hud_stoic_health_" .. BTP:GetOption("stoic_health"),
            texture_rect = {128, 0, -128, 128},
            layer = 20,
            render_template = "VertexColorTexturedRadialFlex",
            w = avatar_size,
            h = avatar_size,
            x = x,
            y = avatar:y(),
            visible = true
        })

        if not self._ai then
            BTP:SetAvatar(self, callback(self, self, "SetAvatar"))
        end
        self.avatar_texture = nil
        self.avatar_texture_rect = nil

        self._player_panel:child("radial_health_panel"):set_visible(false)
        self._condition_icon:set_color(tweak_data.btp.color.default)
        self._condition_icon:set_layer(15)
        self._condition_icon:set_center(self._player_panel:child("avatar"):center())
        self._panel:child("condition_timer"):set_layer(20)
        if self._main_player then
            self._panel:child("name"):set_y(self._panel:child("name"):y() - 8)
            self._panel:child("name_bg"):set_y(self._panel:child("name_bg"):y() - 8)
            self._player_panel:child("revive_panel"):set_y(self._player_panel:child("revive_panel"):y() - 8)
        else
            self._panel:child("name"):set_x(self._panel:child("name"):x() + 4)
            self._panel:child("name_bg"):set_x(self._panel:child("name_bg"):x() + 4)
            self._player_panel:child("revive_panel"):set_x(self._player_panel:child("revive_panel"):x() + 4)
        end
    else -- Place Avatar next to/above Health Bar
        local parent = self._panel:parent()
        local parent_panel = parent:child(tostring(self._id))
        local avatar_size = self._main_player and 64 or 44
        if avatar_position == 2 then -- Left
            if not self._main_player then
                local cable_ties_panel = self._player_panel:child("cable_ties_panel")
                self._grenades_panel:set_x(cable_ties_panel:x())
                self._grenades_panel:set_y(cable_ties_panel:y() - cable_ties_panel:h() - 1)
                parent_panel:set_x(parent_panel:x() + self._grenades_panel:w())
            end
            self._avatar = parent:bitmap({
                name = "avatar",
                texture = "guis/textures/pd2_mod_btp/avatar_none",
                layer = 10,
                w = avatar_size,
                h = avatar_size,
                y = managers.hud:teampanels_height() - avatar_size - 2,
                visible = self._main_player
            })
            self._avatar:set_right(parent_panel:left())
        else -- Top
            self._avatar = parent:bitmap({
                name = "avatar",
                texture = "guis/textures/pd2_mod_btp/avatar_none",
                layer = 10,
                w = avatar_size,
                h = avatar_size,
                x = parent_panel:left(),
                visible = self._main_player
            })
        end
        if not self._ai then
            BTP:SetAvatar(self, callback(self, self, "SetAvatar"))
        end
        self.avatar_texture = nil
        self.avatar_texture_rect = nil
    end

    if self._main_player then
        local stamina_icon = self._player_panel:bitmap({
            name = "stamina_icon",
            texture = tweak_data.btp.textures.stamina_counter.texture,
            texture_rect = tweak_data.btp.textures.stamina_counter.texture_rect,
            layer = 10,
            w = 16,
            h = 16,
            x = 0,
            visible = stamina_counter_visibility
        })
        local stamina_text = self._player_panel:text({
            name = "stamina_text",
            layer = 10,
            text = "100%",
            w = 16,
            h = 16,
            x = 16,
            y = 2.5,
            visible = stamina_icon:visible(),
            font_size = 14,
            font = tweak_data.hud_players.ammo_font,
            color = Color.green
        })
        managers.hud:make_fine_text(stamina_text)
        local armor_break_invulnerable_icon = self._player_panel:bitmap({
            name = "armor_break_invulnerable_icon",
            texture = tweak_data.btp.textures.armor_break_invulnerable.texture,
            texture_rect = tweak_data.btp.textures.armor_break_invulnerable.texture_rect,
            layer = 10,
            w = 16,
            h = 16,
            x = stamina_text:x() + stamina_text:w(),
            y = stamina_text:y() - 1.25,
            visible = false
        })
        local armor_break_invulnerable_text = self._player_panel:text({
            name = "armor_break_invulnerable_text",
            layer = 10,
            text = "0.00",
            w = 16,
            h = 16,
            x = armor_break_invulnerable_icon:right(),
            y = armor_break_invulnerable_icon:y(),
            visible = false,
            font_size = 14,
            font = tweak_data.hud_players.ammo_font,
            color = Color.white
        })
        managers.hud:make_fine_text(armor_break_invulnerable_text)
        self._armor_break_invulnerable_t = 0
    else
        local ping_icon = self._player_panel:bitmap({
            name = "ping_icon",
            texture = tweak_data.btp.textures.ping_counter.texture,
            texture_rect = tweak_data.btp.textures.ping_counter.texture_rect,
            layer = 10,
            w = 16,
            h = 16,
            x = 0,
            y = 16,
            visible = ping_counter_visibility
        })
        local ping_text = self._player_panel:text({
            name = "ping_text",
            layer = 10,
            text = "0000ms",
            w = 16,
            h = 16,
            x = 16,
            y = 18.5,
            visible = ping_icon:visible(),
            font_size = 14,
            font = tweak_data.hud_players.ammo_font,
            color = Color.white
        })
        managers.hud:make_fine_text(ping_text)
        self:ResetPingText()
        if ping_counter_visibility then
            self._carry_panel:set_y(self._carry_panel:y() - 8)
            self._carry_panel:child("bg"):set_w(self._carry_panel:child("bg"):w() / 2)
            self._carry_panel:child("bg"):set_h(self._carry_panel:child("bg"):h() / 2)
            self._carry_panel:child("bg"):set_x(self._carry_panel:child("bg"):x() + 8)
            self._carry_panel:child("bg"):set_y(self._carry_panel:child("bg"):y() + 8)
            self._carry_panel:child("bag"):set_w(self._carry_panel:child("bag"):w() / 2)
            self._carry_panel:child("bag"):set_h(self._carry_panel:child("bag"):h() / 2)
            self._carry_panel:child("bag"):set_x(self._carry_panel:child("bag"):x() + 8)
            self._carry_panel:child("bag"):set_y(self._carry_panel:child("bag"):y() + 8)
        end
    end

    self._interact:set_image(self.armor_texture)
    self._interact._panel:remove(self._interact._bg_circle) -- Removes BG
    self._interact._bg_circle = nil
end

function HUDTeammate:MainPlayerOverride()
    self._avatar:set_visible(avatar_replace)
end

function HUDTeammate:SetMaxStamina(value)
    self._max_stamina = value
end

if BTP:GetOption("stamina_counter_color") then
    function HUDTeammate:SetStaminaValue(value)
        local v = value / self._max_stamina
        self._player_panel:child("stamina_text"):set_text((BTP:RoundNumber(v, 0.01) * 100) .. "%")
        self._player_panel:child("stamina_text"):set_color(Color(1, 1 - (1 * v), 1 * v, 0))
    end
else
    function HUDTeammate:SetStaminaValue(value)
        self._player_panel:child("stamina_text"):set_text((BTP:RoundNumber(value / self._max_stamina, 0.01) * 100) .. "%")
    end
end

function HUDTeammate:SetPingVisibility(visibility)
    if not self._main_player then
        self._player_panel:child("ping_icon"):set_visible(visibility and ping_counter_visibility)
        self._player_panel:child("ping_text"):set_visible(visibility and ping_counter_visibility)
    end
end

if BTP:GetOption("ping_counter_color") then
    function HUDTeammate:SetPingText(ping, desync)
        if not self._main_player then
            self._player_panel:child("ping_text"):set_text(ping .. "ms")
            self._player_panel:child("ping_text"):set_color(BTP:GetPingColor(ping, desync))
        end
    end
else
    function HUDTeammate:SetPingText(ping, desync)
        if not self._main_player then
            self._player_panel:child("ping_text"):set_text(ping .. "ms")
        end
    end
end

function HUDTeammate:ResetPingText()
    self:SetPingText(0)
end

function HUDTeammate:SetAvatar(texture, texture_rect)
    texture = texture or "guis/textures/pd2_mod_btp/avatar_none"
    self._avatar:set_image(texture)
    self.avatar_texture = texture
    self.avatar_texture_rect = texture_rect
end

function HUDTeammate:ReloadSteamAvatar()
    self:SetAvatar()
    self._steam_texture_obtained = nil
    if not self._ai then
        BTP:SetAvatar(self, callback(self, self, "SetAvatar"))
    end
end

BTP:Hook(HUDTeammate, "set_peer_id", function(self, ...)
    BTP:SetAvatar(self, callback(self, self, "SetAvatar"))
    self._avatar:set_visible(avatar_replace)
end)

BTP:PreHook(HUDTeammate, "remove_panel", function(self, ...)
    self:SetAvatar()
    self._steam_texture_obtained = nil
    self._avatar:set_visible(false)
    self:ResetPingText()
end)

if avatar_position == 3 then
    BTP:Hook(HUDTeammate, "set_name", function(self, ...)
        local bottom = self._panel:child("name_bg"):top() - 1
        if stamina_counter_visibility then
            bottom = bottom - 16
        end
        self._avatar:set_bottom(bottom)
    end)

    BTP:Hook(HUDTeammate, "layout_special_equipments", function(self)
        local special_equipment = self._special_equipment
        for i, panel in ipairs(special_equipment) do
            panel:set_y(panel:y() + 120)
        end
    end)
end

function HUDTeammate:SetArmorBreakInvulnerabilityVisibility(visibility, t)
    self._armor_break_invulnerable_t = t
    self._player_panel:child("armor_break_invulnerable_icon"):set_visible(visibility)
    self._player_panel:child("armor_break_invulnerable_text"):set_visible(visibility)
    if visibility then
        managers.hud:add_updator("BTP_ArmorBreakInvulnerable", callback(self, self, "UpdateArmorBreakInvulnerability"))
    else
        managers.hud:remove_updator("BTP_ArmorBreakInvulnerable")
    end
end

local string_format = string.format
local math_floor = math.floor
function HUDTeammate:UpdateArmorBreakInvulnerability(t, dt)
    self._armor_break_invulnerable_t = self._armor_break_invulnerable_t - dt
    if self._armor_break_invulnerable_t <= 0 then
        self:SetArmorBreakInvulnerabilityVisibility(false, 0)
        return
    end
    local ctd = math_floor(self._armor_break_invulnerable_t * 10) / 10
    local text = self._player_panel:child("armor_break_invulnerable_text")
    if ctd < 0 then
        text:set_text(string_format("%d", 0))
    elseif ctd < 1 then
        text:set_text(string_format("%.2f", self._armor_break_invulnerable_t))
    elseif ctd < 10 then
        text:set_text(string_format("%.1f", ctd))
    else
        text:set_text(string_format("%d", ctd))
    end
end

if not avatar_replace then
    return
end

function HUDTeammate:set_health(data)
    self._health_data = data
    local radial_health = self._avatar
    local red = data.current / data.total

    radial_health:stop()

    if red < radial_health:color().red then
        self:_damage_taken()
        radial_health:set_color(Color(1, red, 1, 1))

        self:update_delayed_damage()
    else
        radial_health:animate(function (o)
            local s = radial_health:color().r
            local e = red
            local health_ratio = nil

            over(0.2, function (p)
                health_ratio = math.lerp(s, e, p)

                radial_health:set_color(Color(1, health_ratio, 1, 1))

                self:update_delayed_damage()
            end)
        end)
    end
end

function HUDTeammate:set_stored_health(stored_health_ratio)
    local red = math.min(stored_health_ratio, 1)
    self._player_panel:child("radial_rip"):set_color(Color(1, red / self._stored_health_max, 1, 1))
end

BTP:Hook(HUDTeammate, "set_armor", function(self, data)
    local avatar = self._player_panel:child("avatar_armor")
    avatar:stop()
    avatar:set_color(Color(1, data.total ~= 0 and (data.current / data.total) or 0, 1, 1))
end)

BTP:Hook(HUDTeammate, "set_ability_icon", function(self, icon)
    local texture, texture_rect = tweak_data.hud_icons:get_icon_data(icon, {
        0,
        0,
        32,
        32
    })

    self._player_panel:child("ability_icon"):set_image(texture, unpack(texture_rect))
end)

BTP:Hook(HUDTeammate, "set_ability_radial", function(self, data)
    local progress = data.current / data.total
    self._player_panel:child("ability_meter"):set_color(Color(1, progress, 1, 1))
    self._player_panel:child("ability_icon"):set_visible(progress > 0)
end)

BTP:Hook(HUDTeammate, "activate_ability_radial", function(self, time_left, time_total)
    time_total = time_total or time_left
    local progress_start = time_left / time_total
    local meter = self._player_panel:child("ability_meter")
    local icon = self._player_panel:child("ability_icon")

    local function anim(o)
        icon:set_visible(true)
        over(time_left, function(p)
            local progress = progress_start * math.lerp(1, 0, p)

            meter:set_color(Color(1, progress, 1, 1))
        end)
        icon:set_visible(false)
    end

    meter:stop()
    meter:animate(anim)
end)

function HUDTeammate:teammate_progress(enabled, tweak_data_id, timer, success)
    if not self._ai then
        self._avatar:set_alpha(enabled and 0.2 or 1)
        self._player_panel:child("avatar_armor"):set_alpha(enabled and 0.2 or 1)
    end
    self._player_panel:child("interact_panel"):stop()
	self._player_panel:child("interact_panel"):set_visible(enabled)

    if enabled then
        self._player_panel:child("interact_panel"):animate(callback(self, self, "_animate_label_interact"), self._interact, timer)
    elseif success then
        local panel = self._player_panel
        local bitmap = panel:bitmap({
            blend_mode = "add",
            texture = self.armor_texture,
            layer = 15,
            align = "center",
            rotation = 360,
            valign = "center"
        })

        bitmap:set_size(self._interact:size())
        bitmap:set_position(self._player_panel:child("interact_panel"):x() + 4, self._player_panel:child("interact_panel"):y() + 4)

        local circle = CircleBitmapGuiObject:new(panel, {
            blend_mode = "normal",
            rotation = 360,
            layer = 3,
            radius = self._interact:radius(),
            color = Color.white:with_alpha(1)
        })

        circle:set_position(bitmap:position())
        bitmap:animate(callback(self, self, "_animate_interaction_complete"), circle)
    end
end

function HUDTeammate:_animate_label_interact(panel, interact, timer)
    interact:set_current(0)

    local t = 0

    while timer >= t do
        local dt = coroutine.yield()
        t = t + dt

        interact:set_current(t / timer)
    end

    interact:set_current(1)
end

function HUDTeammate:_animate_interaction_complete(bitmap, circle)
    local TOTAL_T = 0.6
    local t = TOTAL_T
    local mul = 1
    local c_x, c_y = bitmap:center()
    local size = bitmap:w()

    while t > 0 do
        local dt = coroutine.yield()
        t = t - dt
        mul = mul + dt * 0.75

        bitmap:set_size(size * mul, size * mul)
        bitmap:set_center(c_x, c_y)
        bitmap:set_alpha(math.max(t / TOTAL_T, 0))
    end

    bitmap:parent():remove(bitmap)
    circle:remove()
end

function HUDTeammate:set_custom_radial(data)
    local teammate_panel = self._player_panel:child("avatar_swan_song")
    local red = data.current / data.total

    teammate_panel:set_color(Color(1, red, 1, 1))
    teammate_panel:set_visible(red > 0)
end

BTP:PreHook(HUDTeammate, "set_condition", function(self, icon_data, ...)
    if icon_data == "mugshot_swansong" then
        self._condition_icon:set_color(Color.white)
    else
        self._condition_icon:set_color(tweak_data.btp.color.default)
    end
end)

function HUDTeammate:set_stored_health_max(stored_health_ratio)
    self._stored_health_max = stored_health_ratio
end

function HUDTeammate:update_delayed_damage()
	local damage = self._delayed_damage or 0
	--local health_panel = self._radial_health_panel
	--local health_radial = health_panel:child("radial_health")
	--local armor_radial = health_panel:child("radial_shield")
	--local delayed_damage_panel = health_panel:child("radial_delayed_damage")
	--local delayed_damage_armor = delayed_damage_panel:child("radial_delayed_damage_armor")
    --local delayed_damage_health = delayed_damage_panel:child("radial_delayed_damage_health")
    local delayed_damage_health = self._player_panel:child("stoic_health")
	local armor_max = self._armor_data.total
	local armor_current = self._armor_data.current
	local armor_ratio = self._player_panel:child("avatar_armor"):color().r
	local health_max = self._health_data.total
	local health_current = self._health_data.current
	local health_ratio = self._avatar:color().r
	local armor_damage = damage < armor_current and damage or armor_current
	damage = damage - armor_damage
	local health_damage = health_current > damage and damage or health_current
	local armor_damage_ratio = armor_damage > 0 and armor_damage / armor_max or 0
	local health_damage_ratio = health_damage / health_max

	--delayed_damage_armor:set_visible(armor_damage_ratio > 0)
	delayed_damage_health:set_visible(health_damage_ratio > 0)
	--delayed_damage_armor:set_color(Color(1, armor_damage_ratio, 1 - armor_ratio, 0))
	delayed_damage_health:set_color(Color(1, health_damage_ratio, 1 - health_ratio, 0))
end

function HUDTeammate:ActivateArmorBreakInvulnerability(t)
    self._player_panel:child("avatar_swan_song"):stop()
    self._player_panel:child("avatar_swan_song"):animate(function(o)
        o:set_color(Color(1, 1, 1, 1))
        o:set_visible(true)
        over(t, function(p)
            o:set_color(Color(1, 1 - p, 1, 1))
        end)
        o:set_visible(false)
    end)
end