local BTP = BTP
local ping_counter_visibility = BTP:GetOption("show_ping_counter")
function HUDTeammate:InitBTP()
    if self._main_player then
        local stamina_icon = self._player_panel:bitmap({
            name = "stamina_icon",
            texture = tweak_data.btp.textures.stamina_counter.texture,
            texture_rect = tweak_data.btp.textures.stamina_counter.texture_rect,
            layer = 10,
            w = 16,
            h = 16,
            x = 0,
            visible = BTP:GetOption("show_stamina_counter")
        })
        local stamina_text = self._player_panel:text({
            name = "stamina_text",
            layer = 10,
            text = "100%",
            w = 16,
            h = 16,
            x = 16,
            visible = stamina_icon:visible(),
            font_size = 14,
            font = tweak_data.hud_players.ammo_font,
            color = Color.green
        })
        managers.hud:make_fine_text(stamina_text)
        local armor_break_invulnerable_icon = self._player_panel:bitmap({
            name = "armor_break_invulnerable_icon",
            texture = tweak_data.btp.textures.armor_break_invulnerable.texture,
            texture_rect = tweak_data.btp.textures.armor_break_invulnerable.texture_rect,
            layer = 10,
            w = 16,
            h = 16,
            x = stamina_text:x() + stamina_text:w(),
            y = stamina_text:y() - 1.25,
            visible = false
        })
        local armor_break_invulnerable_text = self._player_panel:text({
            name = "armor_break_invulnerable_text",
            layer = 10,
            text = "0.00",
            w = 16,
            h = 16,
            x = armor_break_invulnerable_icon:right(),
            y = armor_break_invulnerable_icon:y(),
            visible = false,
            font_size = 14,
            font = tweak_data.hud_players.ammo_font,
            color = Color.white
        })
        managers.hud:make_fine_text(armor_break_invulnerable_text)
        self._armor_break_invulnerable_t = 0
    else
        local ping_icon = self._player_panel:bitmap({
            name = "ping_icon",
            texture = tweak_data.btp.textures.ping_counter.texture,
            texture_rect = tweak_data.btp.textures.ping_counter.texture_rect,
            layer = 10,
            w = 16,
            h = 16,
            x = 0,
            y = 0,
            visible = ping_counter_visibility
        })
        local ping_text = self._player_panel:text({
            name = "ping_text",
            layer = 10,
            text = "0000ms",
            w = 16,
            h = 16,
            x = 16,
            y = ping_icon:y() + 2.5,
            visible = ping_icon:visible(),
            font_size = 14,
            font = tweak_data.hud_players.ammo_font,
            color = Color.white
        })
        managers.hud:make_fine_text(ping_text)
        self:ResetPingText()
        if ping_counter_visibility then
            self._carry_panel:set_y(self._carry_panel:y() - 8)
            self._carry_panel:child("bg"):set_w(self._carry_panel:child("bg"):w() / 2)
            self._carry_panel:child("bg"):set_h(self._carry_panel:child("bg"):h() / 2)
            self._carry_panel:child("bg"):set_x(self._carry_panel:child("bg"):x() + 8)
            self._carry_panel:child("bg"):set_y(self._carry_panel:child("bg"):y() + 8)
            self._carry_panel:child("bag"):set_w(self._carry_panel:child("bag"):w() / 2)
            self._carry_panel:child("bag"):set_h(self._carry_panel:child("bag"):h() / 2)
            self._carry_panel:child("bag"):set_x(self._carry_panel:child("bag"):x() + 8)
            self._carry_panel:child("bag"):set_y(self._carry_panel:child("bag"):y() + 8)
        end
    end
end

function HUDTeammate:SetMaxStamina(value)
    self._max_stamina = value
end

if BTP:GetOption("stamina_counter_color") then
    function HUDTeammate:SetStaminaValue(value)
        local v = value / self._max_stamina
        self._player_panel:child("stamina_text"):set_text((BTP:RoundNumber(v, 0.01) * 100) .. "%")
        self._player_panel:child("stamina_text"):set_color(Color(1, 1 - (1 * v), 1 * v, 0))
    end
else
    function HUDTeammate:SetStaminaValue(value)
        self._player_panel:child("stamina_text"):set_text((BTP:RoundNumber(value / self._max_stamina, 0.01) * 100) .. "%")
    end
end

function HUDTeammate:SetPingVisibility(visibility)
    if not self._main_player then
        self._player_panel:child("ping_icon"):set_visible(visibility and ping_counter_visibility)
        self._player_panel:child("ping_text"):set_visible(visibility and ping_counter_visibility)
    end
end

if BTP:GetOption("ping_counter_color") then
    function HUDTeammate:SetPingText(ping, desync)
        if not self._main_player then
            self._player_panel:child("ping_text"):set_text(ping .. "ms")
            self._player_panel:child("ping_text"):set_color(BTP:GetPingColor(ping, desync))
        end
    end
else
    function HUDTeammate:SetPingText(ping, desync)
        if not self._main_player then
            self._player_panel:child("ping_text"):set_text(ping .. "ms")
        end
    end
end

function HUDTeammate:ResetPingText()
    self:SetPingText(0)
end

BTP:PreHook(HUDTeammate, "remove_panel", function(self, ...)
    self:ResetPingText()
end)

function HUDTeammate:ActivateArmorBreakInvulnerability(t)
    self._radial_health_panel:child("radial_custom"):stop()
    self._radial_health_panel:child("radial_custom"):animate(function(o)
        o:set_color(Color(1, 1, 1, 1))
        o:set_visible(true)
        over(t, function(p)
            o:set_color(Color(1, 1 - p, 1, 1))
        end)
        o:set_visible(false)
    end)
end

function HUDTeammate:SetArmorBreakInvulnerabilityVisibility(visibility, t)
    self._armor_break_invulnerable_t = t
    self._player_panel:child("armor_break_invulnerable_icon"):set_visible(visibility)
    self._player_panel:child("armor_break_invulnerable_text"):set_visible(visibility)
    if visibility then
        managers.hud:add_updator("BTP_ArmorBreakInvulnerable", callback(self, self, "UpdateArmorBreakInvulnerability"))
    else
        managers.hud:remove_updator("BTP_ArmorBreakInvulnerable")
    end
end

local string_format = string.format
local math_floor = math.floor
function HUDTeammate:UpdateArmorBreakInvulnerability(t, dt)
    self._armor_break_invulnerable_t = self._armor_break_invulnerable_t - dt
    if self._armor_break_invulnerable_t <= 0 then
        self:SetArmorBreakInvulnerabilityVisibility(false, 0)
        return
    end
    local ctd = math_floor(self._armor_break_invulnerable_t * 10) / 10
    local text = self._player_panel:child("armor_break_invulnerable_text")
    if ctd < 0 then
        text:set_text(string_format("%d", 0))
    elseif ctd < 1 then
        text:set_text(string_format("%.2f", self._armor_break_invulnerable_t))
    elseif ctd < 10 then
        text:set_text(string_format("%.1f", ctd))
    else
        text:set_text(string_format("%d", ctd))
    end
end