local Styles =
{
    Avatar = BTP:GetOption("panel_style"),
    AvatarCompatibility = BTP:GetOption("steam_avatar_compatibility"),
    HeisterAvatarStyle = BTP:GetOption("heister_avatar_style"),
}
function BTP:SetAvatar(HUDTeammate, clbk, try)
    if HUDTeammate._steam_texture_obtained then
        return
    elseif Styles.Avatar ~= 1 then
        if Styles.Avatar == 2 then
            self:SetSteamAvatar(HUDTeammate, clbk, try or 0)
        else
            self:SetCharacterAvatar(HUDTeammate, clbk)
        end
    end
end

function BTP:SetSteamAvatar(self, clbk, try)
    if self._steam_texture_obtained then
        return
    end
    local peer = self._peer_id and managers.network:session():peer(self._peer_id) or nil
    local steam_id = peer and peer:account_id() or self._main_player and Steam:userid() or nil
    local avatar_size = self._main_player and (Styles.AvatarCompatibility and 1 or Steam.LARGE_AVATAR) or 1 -- LARGE_AVATAR: 184x184; else 64x64
    if steam_id and not self._ai then
        --[[local function result(success, page)
            if success then
                BTP.SLAXML:parse(page)
            end
        end

        Steam:http_request("https://steamcommunity.com/id/" .. steam_id .. "?xml=1")]]
        Steam:friend_avatar(avatar_size, steam_id, function(texture)
            local avatar = texture or nil
            local tries = 0

            while not avatar or not self._steam_texture_obtained do
                if tries >= 10 then
                    if try <= 10 then
                        local function Refresh()
                            BTP:SetSteamAvatar(self, clbk, try + 1)
                        end
                        BTP:DelayCall("BTP_Refresh" .. tostring(self._main_player) .. tostring(self._peer_id), 10, Refresh)
                        return
                    end
                    BTP:Log("Max tries reached; skip getting Steam Avatar")
                    break
                end

                Steam:friend_avatar(avatar_size, steam_id, function (texture)
                    local avatar = texture or nil

                    if avatar then
                        self._steam_texture_obtained = true
                        clbk(texture)
                    end
                end)

                tries = tries + 1
            end

            if avatar then
                self._steam_texture_obtained = true
                clbk(texture)
            end
        end)
    end
end

function BTP:SetCharacterAvatar(self, clbk)
    local character_name = managers.blackmarket:get_real_character(nil, self._peer_id)
    local guis_catalog = "guis/"
    local bitmap_texture
    if Styles.HeisterAvatarStyle == 1 then
        local character_table = tweak_data.blackmarket.characters[character_name] or tweak_data.blackmarket.characters.locked[character_name]
        local bundle_folder = character_table and character_table.texture_bundle_folder
        if bundle_folder then
            guis_catalog = guis_catalog .. "dlcs/" .. tostring(bundle_folder) .. "/"
        end
        bitmap_texture = guis_catalog .. "textures/pd2/blackmarket/icons/characters/" .. character_name
    else
        local mask = tweak_data.blackmarket.masks.character_locked[character_name] or "dallas"
        local mask_table = tweak_data.blackmarket.masks[mask]
        local bundle_folder = mask_table and mask_table.texture_bundle_folder
        if bundle_folder then
            guis_catalog = guis_catalog .. "dlcs/" .. tostring(bundle_folder) .. "/"
        end
        bitmap_texture = guis_catalog .. "textures/pd2/blackmarket/icons/masks/" .. mask
    end
    clbk(bitmap_texture)
end