local HUDs =
{
    [2] = "Vanilla",
    [3] = "WolfHUD",
    [4] = "SydneyHUD",
    [5] = "MUI",
    [6] = "CS HUD",
    [7] = "Restoration Mod"
}

function BTP:ApplyCompatibility(number, detection)
    number = number or self:GetOption("hud_compatibility")
    detection = detection or number == 1
    if number == 1 then
        if BeardLib then
            if restoration and restoration:all_enabled("HUD/MainHUD", "HUD/Teammate") then
                self:ApplyCompatibility(7, true)
                return
            end
        end
        if ArmStatic and MUIMenu and MUIMenu:ClassEnabled("MUITeammate") and MUIMenu:ClassEnabled("MUILegend") and MUIMenu:ClassEnabled("AnimatedList") then
            self:ApplyCompatibility(5, true)
        elseif WolfHUD and WolfHUD:getSetting({"CustomHUD", "ENABLED"}, true) and HUDManager.CUSTOM_TEAMMATE_PANELS then
            self:ApplyCompatibility(3, true)
        elseif SydneyHUD then
            self:ApplyCompatibility(4, true)
        elseif CSHUD and not CSHUD:IsVROrComponentIsDisabled() then
            self:ApplyCompatibility(6, true)
        else
            self:ApplyCompatibility(2, true)
        end
        return
    end
    local requires_main_code = false
    local hud_file = nil
    if number == 3 then
        hud_file = "wolfhud"
    elseif number == 4 then
        hud_file = "sydneyhud"
        requires_main_code = true
    elseif number == 5 then
        hud_file = "mui"
    elseif number == 6 then
        hud_file = "cshud"
    elseif number == 7 then
        --self:ApplyCompatibilityFile("restoration_mod")
    end
    if number == 2 or requires_main_code then
        if self:GetOption("panel_style") == 1 then
            dofile(self.LuaPath .. "HUDTeammateDefault.lua")
        else
            dofile(self.LuaPath .. "HUDTeammate.lua")
        end
    end
    if hud_file then
        self:ApplyCompatibilityFile(hud_file)
    end
    self:Log((detection and (number == 2 and ("No HUD detected. ") or (HUDs[number] .. " detected. ")) or "") .. HUDs[number] .. " compatibility applied.")
end