local BTP = BTP
local ping_counter_visibility = BTP:GetOption("show_ping_counter")
local stamina_counter_visibility = BTP:GetOption("show_stamina_counter")
function HUDTeammate:InitBTP()
    if self._main_player then
        local stamina_icon = self._csgo:bitmap({
            name = "stamina_icon",
            texture = tweak_data.btp.textures.stamina_counter.texture,
            texture_rect = tweak_data.btp.textures.stamina_counter.texture_rect,
            layer = 10,
            w = 16,
            h = 16,
            x = 0,
            y = 0,
            visible = stamina_counter_visibility and self.avatar:visible()
        })
        local stamina_text = self._csgo:text({
            name = "stamina_text",
            layer = 10,
            text = "100%",
            w = 16,
            h = 16,
            x = 16,
            y = 2.5,
            visible = stamina_icon:visible(),
            font_size = 14,
            font = tweak_data.hud_players.ammo_font,
            color = Color.green
        })
        managers.hud:make_fine_text(stamina_text)
        local armor_break_invulnerable_icon = self._csgo:bitmap({
            name = "armor_break_invulnerable_icon",
            texture = tweak_data.btp.textures.armor_break_invulnerable.texture,
            texture_rect = tweak_data.btp.textures.armor_break_invulnerable.texture_rect,
            layer = 10,
            w = 16,
            h = 16,
            x = 16,
            y = stamina_icon:y() + 16,
            visible = false
        })
        local armor_break_invulnerable_text = self._csgo:text({
            name = "armor_break_invulnerable_text",
            layer = 10,
            text = "0.00",
            w = 16,
            h = 16,
            x = armor_break_invulnerable_icon:right(),
            y = armor_break_invulnerable_icon:y(),
            visible = false,
            font_size = 14,
            font = tweak_data.hud_players.ammo_font,
            color = Color.white
        })
        managers.hud:make_fine_text(armor_break_invulnerable_text)
        self._armor_break_invulnerable_t = 0
        if stamina_counter_visibility or ping_counter_visibility then
            if self._panel_pos == 1 then -- Top
                self._csgo:child("playing_on"):set_y(self._csgo:child("playing_on"):y() + 16)
            else
                self._csgo:child("playing_on"):set_y(self._csgo:child("playing_on"):y() - 16)
            end
        end
    else
        local ping_icon = self._csgo:bitmap({
            name = "ping_icon",
            texture = tweak_data.btp.textures.ping_counter.texture,
            texture_rect = tweak_data.btp.textures.ping_counter.texture_rect,
            layer = 10,
            w = 16,
            h = 16,
            x = 0,
            y = 0,
            visible = false
        })
        local ping_text = self._csgo:text({
            name = "ping_text",
            layer = 10,
            text = "0000ms",
            w = 16,
            h = 16,
            x = 16,
            y = 2.5,
            visible = ping_icon:visible(),
            font_size = 14,
            font = tweak_data.hud_players.ammo_font,
            color = Color.white
        })
        managers.hud:make_fine_text(ping_text)
        self:ResetPingText()
    end
    self:SetPanelX()
end

function HUDTeammate:SetMaxStamina(value)
    self._max_stamina = value
end

if BTP:GetOption("stamina_counter_color") then
    function HUDTeammate:SetStaminaValue(value)
        local v = value / self._max_stamina
        self._csgo:child("stamina_text"):set_text((BTP:RoundNumber(v, 0.01) * 100) .. "%")
        self._csgo:child("stamina_text"):set_color(Color(1, 1 - v, v, 0))
    end
else
    function HUDTeammate:SetStaminaValue(value)
        self._csgo:child("stamina_text"):set_text((BTP:RoundNumber(value / self._max_stamina, 0.01) * 100) .. "%")
    end
end

function HUDTeammate:SetPingVisibility(visibility)
    if not self._main_player then
        self._csgo:child("ping_icon"):set_visible(visibility and ping_counter_visibility)
        self._csgo:child("ping_text"):set_visible(visibility and ping_counter_visibility)
    end
end

if BTP:GetOption("ping_counter_color") then
    function HUDTeammate:SetPingText(ping, desync)
        if not self._main_player then
            self._csgo:child("ping_text"):set_text(ping .. "ms")
            self._csgo:child("ping_text"):set_color(BTP:GetPingColor(ping, desync))
        end
    end
else
    function HUDTeammate:SetPingText(ping, desync)
        if not self._main_player then
            self._csgo:child("ping_text"):set_text(ping .. "ms")
        end
    end
end

function HUDTeammate:ResetPingText()
    self:SetPingText(0)
end

BTP:PreHook(HUDTeammate, "remove_panel", function(self, weapons_panel)
    self:ResetPingText()
end)

local _f_SetPanelX = HUDTeammate.SetPanelX
function HUDTeammate:SetPanelX(i)
    _f_SetPanelX(self, i)
    if self._main_player then
        if stamina_counter_visibility then
            if self._panel_pos == 1 then -- Top
                self._csgo:child("stamina_icon"):set_top(self._down_icon:bottom())
                self._csgo:child("armor_break_invulnerable_icon"):set_top(self._csgo:child("stamina_icon"):bottom())
                self._carry:set_top(self._csgo:child("stamina_icon"):bottom())
            else
                self._csgo:child("stamina_icon"):set_bottom(self._down_icon:top())
                self._csgo:child("armor_break_invulnerable_icon"):set_bottom(self._csgo:child("stamina_icon"):top())
                self._carry:set_bottom(self._csgo:child("stamina_icon"):top())
            end
            self._csgo:child("stamina_icon"):set_x(self._down_icon:x())
            self._csgo:child("stamina_text"):set_top(self._csgo:child("stamina_icon"):top() + 2.5)
            self._csgo:child("stamina_text"):set_x(self._csgo:child("stamina_icon"):x() + 16)
            self._csgo:child("armor_break_invulnerable_icon"):set_x(self._csgo:child("stamina_icon"):x())
            self._csgo:child("armor_break_invulnerable_text"):set_top(self._csgo:child("armor_break_invulnerable_icon"):top() + 2.5)
            self._csgo:child("armor_break_invulnerable_text"):set_x(self._csgo:child("armor_break_invulnerable_icon"):x() + 16)
        else
            if self._panel_pos == 1 then -- Top
                self._csgo:child("armor_break_invulnerable_icon"):set_top(self._down_icon:bottom())
                self._carry:set_top(self._csgo:child("armor_break_invulnerable_icon"):bottom())
            else
                self._csgo:child("armor_break_invulnerable_icon"):set_bottom(self._down_icon:top())
                self._carry:set_bottom(self._csgo:child("armor_break_invulnerable_icon"):top())
            end
            self._csgo:child("armor_break_invulnerable_icon"):set_x(self._down_icon:x())
            self._csgo:child("armor_break_invulnerable_text"):set_top(self._csgo:child("armor_break_invulnerable_icon"):top() + 2.5)
            self._csgo:child("armor_break_invulnerable_text"):set_x(self._csgo:child("armor_break_invulnerable_icon"):x() + 16)
        end
    else
        if self._panel_pos == 1 then -- Top
            self._csgo:child("ping_icon"):set_top(self._down_icon:bottom())
        else
            self._csgo:child("ping_icon"):set_bottom(self._down_icon:top())
        end
        self._csgo:child("ping_icon"):set_x(self._down_icon:x())
        self._csgo:child("ping_text"):set_top(self._csgo:child("ping_icon"):top() + 2.5)
        self._csgo:child("ping_text"):set_x(self._csgo:child("ping_icon"):x() + 16)
    end
end

function HUDTeammate:ReloadSteamAvatar()
end

function HUDTeammate:ActivateArmorBreakInvulnerability(t)
    self.avatar:child("radial_custom"):stop()
    self.avatar:child("radial_custom"):animate(function(o)
        o:set_color(Color(1, 1, 1, 1))
        o:set_visible(true)
        if self._main_player then
            over(t, function(p)
                o:set_color(Color(1, 1 - p, 1, 1))
                self:set_custom_radial({ current = 1 - p, total = 1 })
            end)
        else
            over(t, function(p)
                o:set_color(Color(1, 1 - p, 1, 1))
            end)
        end
        o:set_visible(false)
    end)
end

function HUDTeammate:SetArmorBreakInvulnerabilityVisibility(visibility, t)
    self._armor_break_invulnerable_t = t
    self._csgo:child("armor_break_invulnerable_icon"):set_visible(visibility)
    self._csgo:child("armor_break_invulnerable_text"):set_visible(visibility)
    if visibility then
        managers.hud:add_updator("BTP_ArmorBreakInvulnerable", callback(self, self, "UpdateArmorBreakInvulnerability"))
        if self._panel_pos == 1 then -- Top
            self._carry:set_top(self._csgo:child("armor_break_invulnerable_icon"):bottom())
        else
            self._carry:set_bottom(self._csgo:child("armor_break_invulnerable_icon"):top())
        end
    else
        managers.hud:remove_updator("BTP_ArmorBreakInvulnerable")
        if self._panel_pos == 1 then -- Top
            self._carry:set_top(self._csgo:child("stamina_icon"):bottom())
        else
            self._carry:set_bottom(self._csgo:child("stamina_icon"):top())
        end
    end
end

local string_format = string.format
local math_floor = math.floor
function HUDTeammate:UpdateArmorBreakInvulnerability(t, dt)
    self._armor_break_invulnerable_t = self._armor_break_invulnerable_t - dt
    if self._armor_break_invulnerable_t <= 0 then
        self:SetArmorBreakInvulnerabilityVisibility(false, 0)
        return
    end
    local ctd = math_floor(self._armor_break_invulnerable_t * 10) / 10
    local text = self._csgo:child("armor_break_invulnerable_text")
    if ctd < 0 then
        text:set_text(string_format("%d", 0))
    elseif ctd < 1 then
        text:set_text(string_format("%.2f", self._armor_break_invulnerable_t))
    elseif ctd < 10 then
        text:set_text(string_format("%.1f", ctd))
    else
        text:set_text(string_format("%d", ctd))
    end
end

if stamina_counter_visibility or ping_counter_visibility then
    if CSHUD:GetOption("cs_hud") == 1 or (CSHUD:GetOption("avatar_time_panel_position") == 1 and CSHUD:GetOption("cs_hud") == 2) then
        BTP:Hook(IngameMaskOffState, "at_enter", function(self, ...)
            local hud = managers.hud
            if hud:alive(self._MASK_OFF_HUD) then
                local text = hud:script("guis/mask_off_hud").mask_on_text
                text:set_y(text:y() + 16)
            end
        end)
    end
    if ping_counter_visibility then
        BTP:Hook(HUDTeammate, "MoveHUDElementsPlayer", function(self, ...)
            self._carry:set_y(self._panel_pos == 1 and self.avatar:bottom() + 32 or self.avatar:top() - 64)
        end)
    end
end