function HUDTeammate:InitBTP()
    local v = BTP:GetOption("panel_style") ~= 1
    local y = self._panel:child("mask"):y()
    local radial_size = self._main_player and 60 or 44
    local avatar_size = self._main_player and 4 or 3
    local x = self._main_player and 4 or 3
    local avatar = self._player_panel:bitmap({
        name = "avatar",
        texture = "guis/textures/pd2_mod_btp/avatar_none",
        layer = 10,
        render_template = "VertexColorTexturedRadial",
        w = radial_size + avatar_size,
        h = radial_size + avatar_size,
        x = x,
        y = y,
        alpha = v and 1 or 0,
        visible = true
    })
    avatar:set_bottom(self._player_panel:h() - 4)

    self.armor_texture = "guis/textures/pd2_mod_btp/hud_armor_" .. BTP:GetOption("armor_color")

    local avatar_armor = self._player_panel:bitmap({
        name = "avatar_armor",
        texture = self.armor_texture,
        layer = 11,
        render_template = "VertexColorTexturedRadial",
        w = radial_size + (avatar_size * 3),
        h = radial_size + (avatar_size * 3),
        x = 0,
        y = y,
        alpha = v and 1 or 0,
        visible = true
    })
    avatar_armor:set_bottom(self._player_panel:h())

    local avatar_interact = self._player_panel:bitmap({
        name = "avatar_interact",
        texture = self.armor_texture,
        layer = 12,
        render_template = "VertexColorTexturedRadial",
        w = radial_size + (avatar_size * 3),
        h = radial_size + (avatar_size * 3),
        x = 0,
        y = y,
        alpha = v and 1 or 0,
        color = Color(1, 0, 1, 1),
        visible = true
    })
    avatar_interact:set_bottom(self._player_panel:h())

    local avatar_ability_radial = self._player_panel:bitmap({
        name = "ability_meter",
        texture = "guis/textures/pd2_mod_btp/hud_ability_radial",
        layer = 13,
        render_template = "VertexColorTexturedRadial",
        w = radial_size + (avatar_size * 3),
        h = radial_size + (avatar_size * 3),
        x = 0,
        y = y,
        alpha = v and 1 or 0,
        visible = true,
        color = Color(1, 0, 0, 0)
    })
    avatar_ability_radial:set_bottom(self._player_panel:h())

    local avatar_ability_radial_icon = self._player_panel:bitmap({
        blend_mode = "add",
        name = "ability_icon",
        alpha = v and 1 or 0,
        visible = false,
        layer = 13,
        w = radial_size * 0.5,
        h = radial_size * 0.5
    })
    avatar_ability_radial_icon:set_center(self._player_panel:child("avatar"):center())

    if not self._ai and v then
        BTP:SetAvatar(self, callback(self, self, "SetAvatar"))
    end
    self.avatar_texture = nil
    self.avatar_texture_rect = nil

    if v then
        self._player_panel:child("radial_health_panel"):set_visible(false)
        self._condition_icon:set_color(tweak_data.btp.color.default)
        self._condition_icon:set_layer(15)
        self._panel:child("condition_timer"):set_layer(20)
    end
end