local panel_style = BTP:GetOption("panel_style")
local _BTP_InitBTP = HUDTeammate.InitBTP
function HUDTeammate:InitBTP()
    _BTP_InitBTP(self)
    local font_size = SydneyHUD:GetOption("counter_font_size")
    if BTP:GetHUDOption("sydneyhud", "stamina_bar_position") == 1 and panel_style ~= 1 then
        self._stamina_bar = self._player_panel:child("avatar")
    else
        if self._main_player then
            self._player_panel:child("stamina_icon"):set_visible(true)
            self._player_panel:child("stamina_text"):set_visible(true)
            self._player_panel:child("stamina_text"):set_font_size(font_size)
            self:set_stamina_meter_visibility(true)
        end
    end
    local detection_icon = self._player_panel:bitmap({
        name = "detection_icon",
        texture = "guis/textures/pd2/skilltree_2/icons_atlas_2",
        texture_rect = { 800, 800, 80, 80 },
        layer = 10,
        w = 16,
        h = 16,
        x = 36,
        y = 0,
        visible = SydneyHUD:GetOption("show_detection_rate") and managers.groupai:state():whisper_mode() or false
    })
    local detection_text = self._player_panel:text({
        name = "detection_text",
        layer = 10,
        text = "75",
        w = 16,
        h = 16,
        x = 52,
        y = 2.5,
        visible = detection_icon:visible(),
        font_size = font_size,
        font = tweak_data.hud_players.ammo_font
    })
    managers.hud:make_fine_text(detection_text)
    if self._main_player then
        self:set_detection_risk((managers.blackmarket:get_suspicion_offset_of_outfit_string(managers.blackmarket:unpack_outfit_from_string(managers.blackmarket:outfit_string()), tweak_data.player.SUSPICION_OFFSET_LERP or 0.75)))
    end
end

function HUDTeammate:set_max_stamina(value)
    self._max_stamina = value
    self:set_stamina_meter_visibility(true)
end

if BTP:GetHUDOption("sydneyhud", "stamina_bar_position") == 1 and panel_style ~= 1 then
    function HUDTeammate:set_current_stamina(value)
        if self._stamina_bar then
            self._stamina_bar:set_alpha(value / self._max_stamina)
        end
    end
else
    function HUDTeammate:set_current_stamina(value)
        self._player_panel:child("stamina_text"):set_text((BTP:RoundNumber(value / self._max_stamina, 0.01) * 100) .. "%")
    end

    function HUDTeammate:set_stamina_meter_visibility(visible)
        if self._player_panel and self._player_panel:child("stamina_icon") and self._player_panel:child("stamina_text") then
            local visibility = visible and SydneyHUD:GetOption("show_stamina_meter") and not self._is_in_custody
            self._player_panel:child("stamina_icon"):set_visible(visibility)
            self._player_panel:child("stamina_text"):set_visible(visibility)
        end
    end
end

function HUDTeammate:set_detection_visibility(visible)
    if SydneyHUD:GetOption("show_detection_rate") and self._player_panel and self._player_panel:child("detection_icon") and self._player_panel:child("detection_text") then
        local visibility = managers.groupai:state():whisper_mode() and visible and not self._is_in_custody
        self._player_panel:child("detection_icon"):set_visible(visibility)
        self._player_panel:child("detection_text"):set_visible(visibility)
    end
end

function HUDTeammate:set_detection_risk(risk)
    if self._player_panel and self._player_panel:child("detection_text") then
        self._player_panel:child("detection_text"):set_text(string.format("%.0f", risk * 100))
        self._player_panel:child("detection_text"):set_color(Color(1, 0.99, 0.08, 0) * (risk / 0.75) + Color(1, 0, 0.71, 1) * (1 - risk / 0.75))
    end
end