dofile(BTP.LuaPath .. "BTPMenu.lua")

Hooks:Add("LocalizationManagerPostInit", "LocalizationManagerPostInit_BTP", function(loc)
    local language_filename = nil
    if BTP.settings.mod_language == 1 then
        local LanguageKey =
        {
            ["PAYDAY 2 THAI LANGUAGE Mod"] = "thai",
            ["Ultimate Localization Manager & 正體中文化"] = "tchinese",
            ["PAYDAY 2 Translate in Portuguese Brazilian"] = "portuguese-br",
            ["Payday 2 Korean patch"] = "korean"
        }
        for _, mod in pairs(BLT and BLT.Mods and BLT.Mods:Mods()) do
            language_filename = mod:IsEnabled() and LanguageKey[mod:GetName()] or nil
            if language_filename then
                break
            end
        end
        if not language_filename then
            for _, filename in pairs(file.GetFiles(BTP.LocPath)) do
                local str = filename:match('^(.*).json$')
                if str and Idstring(str) and Idstring(str):key() == SystemInfo:language():key() then
                    language_filename = str
                    break
                end
            end
        end
        if language_filename then
            BTP.Language = language_filename
            loc:load_localization_file(BTP.LocPath .. language_filename .. ".json")
        end
    else
        local Languages =
        {
            [2] = "english",
            [3] = "french",
            [4] = "spanish",
            [5] = "thai",
            [6] = "czech",
            [7] = "german",
            [8] = "italian",
            [9] = "russian",
            [10] = "schinese",
            [11] = "tchinese",
            [12] = "portuguese-br",
            [13] = "korean"
        }
        BTP.Language = Languages[BTP.settings.mod_language]
        loc:load_localization_file(BTP.LocPath .. BTP.Language .. ".json")
    end
    if BTP.Language ~= "english" or not language_filename then
        loc:load_localization_file(BTP.LocPath .. "english.json", false)
    end
    loc:load_localization_file(BTP.LocPath .. "languages.json")
    loc:load_localization_file(BTP.LocPath .. "common.json", false)
end)

Hooks:Add("MenuManagerBuildCustomMenus", "MenuManagerBuildCustomMenus_BTP", function(menu_manager, nodes)
    MenuCallbackHandler.OpenBTPModOptions = function(self, item)
        BTP.Menu = BTP.Menu or BTPMenu:new()
		BTP.Menu:Open()

        -- Add Hook when menu is created
        if not BTP.MenuHooks then
            Hooks:PostHook(MenuManager, "update", "update_menu_BTP", function(self, t, dt)
                if BTP.Menu and BTP.Menu.update and BTP.Menu._enabled then
                    BTP.Menu:update(t, dt)
                end
            end)
            BTP.MenuHooks = true
        end
	end

	local node = nodes["blt_options"]

	local item_params = {
		name = "BTP_OpenMenu",
		text_id = "btp_mod_title",
		help_id = "btp_mod_desc",
		callback = "OpenBTPModOptions",
		localize = true,
	}
	local item = node:create_item({type = "CoreMenuItem.Item"}, item_params)
    node:add_item(item)
end)